#include "ReadSegment.h"

int Rdf::EventCount;
int Rdf::BlockCount;

Rdf::Rdf(void){

    EndOfEvent=true;
    BlockCount=1;
    EventCount=0;

    for(int i=0; i<16; i++)
        scaler[i] = 0;


}

Rdf::~Rdf(void){
}

void Rdf::OpenRdf(char *filename){

/*  This function is necessary for loop to set the pointer at begging of the rdf file.  */

    rdf = fopen(filename,"rb");
    if(rdf==NULL){
        cout << "File not found." << endl;
        exit(1);
    }
    cout << " File opening ... " << endl;
    fseek(rdf, BlockSize, SEEK_SET);
    fread(BlockData, sizeof(short), BlockSize/2, rdf);
    Element=4;

}

void Rdf::CloseRdf(){

    fclose(rdf);
    cout << "File closed." << endl;
}

void Rdf::SortRdf(){

    if(EventCount>0)
        NextEvent();
    EventCount++;

    for(short i=0;i<16;i++){
        SegmentElement[i]=0;
    }
    EventWords = ReadWords(&BlockData[Element]);
//    cout << " Event " << EventCount << " : words " << EventWords << endl;

    Element += 3;

    short words=3;
    short SegID;
    while(words<EventWords){
        words += BlockData[Element];
        SegID = BlockData[Element+1];
        SegmentElement[SegID]=Element+2;
        Element += BlockData[Element];
   }

}

short* Rdf::ReadSegment(short SegID, short Event){

    return SegmentElement[SegID]==0||((0>Event)||(Event>BlockData[SegmentElement[SegID]-2]-1))
        ? &BlockData[1]
        : &BlockData[SegmentElement[SegID]+Event];
}

short Rdf::SegAuthenticity(short SegID){
    return SegmentElement[SegID]==0
        ? 0
        : BlockData[SegmentElement[SegID]-2];
}
