#ifndef CHANNELMAP_H
#define CHANNELMAP_H

#include <iostream>
#include <fstream>
//#include <strstream.h>
#include <strstream>
#include <string.h>
#include <stdio.h>
//#include "rootbasic.h"

using namespace std;

//Max module number//channel number. 
//if N_Module can be a much larger number, we have to reconsider the logic.

#define N_MODULE_MAX  20
#define N_CHANNEL_MAX 64
#define MAX_FILENAME_LENGTH 200


class ChannelMap {
 private:
  int  maparray[N_MODULE_MAX+1][N_CHANNEL_MAX+1];
  int  maxmodule=N_MODULE_MAX;
  int  maxchannel=N_CHANNEL_MAX;
  char filename[MAX_FILENAME_LENGTH+1]; 
  bool map_read;
  int maxid;
 public:
  ChannelMap();
  ChannelMap(char *in_filename) {ReadMap(in_filename);};
  ~ChannelMap() {};

  void SetMapFile(const char *in_filename) {strcpy(filename,in_filename);};
  int ReadMap();
  int ReadMap(const char *in_filename) {SetMapFile(in_filename);return ReadMap();};
  void PrintMap();
  int Map(int n_mod, int n_channel);
  void SetMapDatum(int id, int n_mod, int n_channel) {maparray[n_mod][n_channel]=id;};
  bool MapRead() {return map_read;}
  bool Mapped(int n_mod, int n_channel) {return (maparray[n_mod][n_channel]!=0);};
  int MaxId() {return maxid;};
};

#endif //CHANNELMAP_H
