#ifndef DATADECORDER_H
#define DATADECORDER_H

#include <iostream>
#include <fstream>
#include <strstream>
#include <stdio.h>
#include "ChannelMap.h"

using namespace std;

#define BLOCKSIZE 16384

class DataDecoder : public ChannelMap {
 protected:
  //unsigned char buff[BLOCKSIZE];
  int decoder_type;
  char decoder_type_name[50];
  //  ifstream in;
  

 public:
  DataDecoder();
  DataDecoder(const char *dtypename);
  DataDecoder(const char *dtypename,const char *mapfilename);
  ~DataDecoder();
  //  int Open(char *str);
  //  int Read();

  //  unsigned char *GetBuffer() {return buff;};
  //  int GetWord(int position) {return int(buff[position<<1]+(buff[(position<<1)+1]<<8));};
  //  unsigned char *GetWordAddress(int position) {return &buff[position<<1];};
  //  int GetBlockSize() {return BLOCKSIZE;};
  int SetDecoderType(const char *dtypename);
  char *DecoderTypeName() {return decoder_type_name;}

  int Decode(int nwords, short *raw, short *decoded);
  int DecodeRaw(int nwords, short *raw, short *decoded);
  int DecodeBit(int nwords, short *raw, short *decoded);
  int DecodeLeCroy(int nwords, short *raw, short *decoded);
  int DecodeCaen(int nwords, short *raw, short *decoded);

  //  bool IsHeader() {return (buff[0]==0x01 && buff[1]==0x00);};
  //  bool IsEnder() {return (buff[0]==0xff && buff[1]==0xff);};

};


#endif //DATADECORDER_H
